/**
 * 
 */
package sim.geometry;

import java.util.ArrayList;
import java.util.List;

import sim.exception.SNoImplementationException;
import sim.exception.SRuntimeException;
import sim.math.SVector3d;

/**
 * <p>
 * La classe <b>SGeometricDiscretization</b> possde des outils permettant de discrtiser une gomtrie. 
 * Elle permet entre autre de reprsenter une gomtrie  l'aide de plusieurs points.
 * </p>
 * 
 * @author Simon Vzina
 * @since 2017-06-06
 * @version 2018-09-05 (labo - La loi de Coulomb v1.1)
 */
public class SGeometricDiscretization {

  /**
   * Mthode permettant de discrtiser une ligne situ le long de l'axe x positif en une multitude de points tous quitablement espacs.
   * 
   * @param size La longueur de la ligne.
   * @param N Le nombre de points le long de la ligne.
   * @return La liste des points composant la ligne.
   * @throws SRuntimeException Si la taille de la ligne est ngatif.
   * @throws SRuntimeException Si le nombre de particules N est infrieur  2.
   */
  public static List<SVector3d> positiveLineXDiscretization(double size, int N) throws SRuntimeException
  {
    // Vrification des donnes.
    if(size < 0)
      throw new SRuntimeException("Erreur SGeometricDiscretization 001 : La taille d'un ligne size = " + size + " doit tre positive.");
    
    if(N < 2)
      throw new SRuntimeException("Erreur SGeometricDiscretization 002 : Le nombre de points N = " + N + " pour dfinir une ligne doit contenir un minimum de 2 points.");
    
    // Allocation de la mmoire de la liste.
    List<SVector3d> list = new ArrayList<SVector3d>();
    
    throw new SNoImplementationException("La mthode n'a pas t implmente.");
  }
      
  /**
   * Mthode permettant de discrtiser un carr situ dans le plan positif xy en une multitude de points tous quitablement espacs.
   * 
   * @param size La taille du carr.
   * @param N Le nombre de points par dimension du carr.
   * @return Le tableau des points composant le carr.
   * @throws SRuntimeException Si la taille du carr est ngatif.
   * @throws SRuntimeException Si le nombre de particules N est infrieur  2.
   */
  public static List<SVector3d> positiveSquareXYDiscretization(double size, int N) throws SRuntimeException
  {
    // Vrification des donnes.
    if(size < 0)
      throw new SRuntimeException("Erreur SGeometricDiscretization 003 : La taille d'un ligne size = " + size + " doit tre positive.");
    
    if(N < 2)
      throw new SRuntimeException("Erreur SGeometricDiscretization 004 : Le nombre de points N = " + N + " pour dfinir un ct du carr doit contenir un minimum de 2 points.");
    
    // Allocation de la mmoire de la liste.
    List<SVector3d> list = new ArrayList<SVector3d>();
    
    throw new SNoImplementationException("La mthode n'a pas t implmente.");
  }
  
}// fin de la classe SGeometricDiscretization
