/**
 * 
 */
package sim.util;

import java.io.BufferedWriter;
import java.io.IOException;

/**
 * L'interface <b>SWriteable</b> reprsente un objet pouvant crire ses paramtres dans un fichier txt.
 * 
 * @author Simon Vzina
 * @since 2015-01-09
 * @version 2016-01-15
 */
public interface SWriteable {

	
  
  /**
	 * Mthode pour crire un objet <b>SWriteable</b> dans un fichier txt en utilisant un <b>BufferedWriter</b>.
	 * 
	 * @param bw - Le buffer pour l'criture.
	 * @throws IOException Si une erreur de type I/O a t lance par l'objet BufferedWriter.
	 * @see BufferedWriter
	 */
	public void write(BufferedWriter bw) throws IOException;
	
}//fin interface SWriteable
